/***********************************************************************
 *
 *	file: config.h
 *
 */

#ifndef CONFIG_H__
#define CONFIG_H__

#ifndef DEBUG
#define DEBUG 0
#endif

#define USE_DT 0

#include "mtytypes.h"

/****************************************************************
 *
 *	USE_MMX ... i686-mmx
 *
 *	P6, K7 ȑÕA[LeN`ł͂𗘗pׂB
 *
 */

#if defined(USE_MMX)

#define N_STRIDE 6
typedef uint64_t	WS_T;
typedef uint32_t	ALU_T;

#define CRYPT64_CLOBBER	/* "%ecx", "%edx", */

/****************************************************************
 *
 *	USE_64 ... x64-alu
 *
 *	AMD64 K8(Opteron, Athlon64)ł́AXMMALU̕B
 *	64-bit ALU ɑ΂ 3-issue.
 *
 */

#elif defined(USE_64)	/* 64-bit ALU */

#define N_STRIDE 6
typedef uint64_t	WS_T;
typedef uint64_t	ALU_T;

#define CRYPT64_CLOBBER /* "%rcx", "%rdx",*/ "%r8", "%r9",

/****************************************************************
 *
 *	USE_64_XMM ... x64-xmm
 *
 *	Core2 Microarchitecture ́A
 *	128-bit XMM Z悭łB
 *
 */

#elif defined(USE_64_XMM)

#define N_STRIDE 7
typedef DQWORD_T	WS_T;
typedef uint64_t	ALU_T;

#define CRYPT64_CLOBBER /* "%rcx", "%rdx",*/
				   
/****************************************************************
 *
 *	USE_XMM ... default
 *
 *	SSE2ΉƌĂA[LeN`ł͑ÓB
 *
 */

#else	/* XMM */

#define N_STRIDE 7
typedef DQWORD_T	WS_T;
typedef uint32_t	ALU_T;

#define CRYPT64_CLOBBER /* "%ecx", "%edx", */

#endif

#include <limits.h>
#define ALU_BITS	(CHAR_BIT * sizeof(ALU_T))

#endif /* CONFIG_H__ */

/*
 *	Local Variables:
 *		tab-width:	4
 *	End:
 *
 * EOF */
